/*
Encompasses: The Path for Balloons, Balloon Movement
 */

// ------- CODE FOR THE PATH
ArrayList<float[]> points = new ArrayList<float[]>(); // The points on the path, in order.
final float PATH_RADIUS = 20;
void addPointToPath(float x, float y) {
  points.add(new float[]{x, y});
}

void addTurn(float x, float y, float angleOption){
  points.add(new float[]{x,y,angleOption});
}


void initPath() {
  addPointToPath(0, 200);
  addPointToPath(50, 200);
  addTurn(0,0,0);
  addPointToPath(200, 150);
  addPointToPath(350, 200);
  addPointToPath(500, 150);
  addPointToPath(650, 200);
  addPointToPath(650, 300);
  addPointToPath(500, 250);
  addPointToPath(350, 300);
  addPointToPath(200, 250);
  addPointToPath(50, 300);
  addPointToPath(50, 400);
  addPointToPath(200, 350);
  addPointToPath(350, 400);
  addPointToPath(500, 350);
  addPointToPath(650, 400);
  addPointToPath(800, 350);
}

ArrayList<float[]> constructCriticalValues(ArrayList<float[]> points){
    ArrayList<float[]> criticalValues = new ArrayList<float[]>();
    for (int i = 0; i < points.size() -1; i++){
      startPoint = points.get(i);
      endPoint = points.get(i+1);
      if (point.length == 2){
        criticalValues.add({dist(point)})
      }
    }
    
}

void drawPath() {
  stroke(#4C6710);
  strokeWeight(PATH_RADIUS * 2 + 1);
  for (int i = 0; i < points.size() - 1; i++) {
    PVector currentPoint = new PVector(points.get(i)[0],points.get(i)[1]);
    PVector nextPoint = new PVector(points.get(i+1)[0],points.get(i+1)[1]);
    line(currentPoint.x, currentPoint.y, nextPoint.x, nextPoint.y);
  }

  stroke(#7b9d32);
  strokeWeight(PATH_RADIUS * 2);
  for (int i = 0; i < points.size() - 1; i++) {
    PVector currentPoint = new PVector(points.get(i)[0],points.get(i)[1]);
    PVector nextPoint = new PVector(points.get(i+1)[0],points.get(i+1)[1]);
    line(currentPoint.x, currentPoint.y, nextPoint.x, nextPoint.y);
  }
}

HashMap<Float, PVector> dp = new HashMap<Float, PVector>();
// GIVEN TO PARTICIPANTS BY DEFAULT
PVector getLocation(float travelDistance)
{
  PVector memoized = dp.get(travelDistance);
  if(memoized != null) {
    return memoized;
  }
  float originalDist = travelDistance;
  for (int i = 0; i < points.size() - 1; i++) {
    PVector currentPoint = new PVector(points.get(i)[0],points.get(i)[1]);
    PVector nextPoint = new PVector(points.get(i+1)[0],points.get(i+1)[1]);
    float distance = dist(currentPoint.x, currentPoint.y, nextPoint.x, nextPoint.y);
    if (distance <= EPSILON || travelDistance >= distance) {
      travelDistance -= distance;
    } else {
      // In between two points
      float travelProgress = travelDistance / distance;
      float xDist = nextPoint.x - currentPoint.x;
      float yDist = nextPoint.y - currentPoint.y;
      float x = currentPoint.x + xDist * travelProgress;
      float y = currentPoint.y + yDist * travelProgress;
      dp.put(originalDist, new PVector(x, y));
      return new PVector(x, y);
    }
  }
  // At end of path
  dp.put(originalDist, new PVector(points.get(points.size() - 1)[0],points.get(points.size() - 1)[1]));
  return new PVector(points.get(points.size() - 1)[0],points.get(points.size() - 1)[1]);
}
